;real idt
db 0x90
idt_table:
    %rep 256
    dw 0
    dw 0x08
    db 0
    db 0x8E
    dw 0
    %endrep
idt_e:
idt_rt:
    dw idt_e - idt_table - 1
    dd idt_table



;isr
exception_hdr:
    cli
    hlt
    ret

%macro isr_err_stub 1
isr_stub_%+%1:
    call exception_hdr
    iret 
%endmacro
; if writing for 64-bit, use iretq instead
%macro isr_no_err_stub 1
isr_stub_%+%1:
    call exception_hdr
    iret
%endmacro

real_isr:
    isr_no_err_stub 0
    isr_no_err_stub 1
    isr_no_err_stub 2
    isr_no_err_stub 3
    isr_no_err_stub 4
    isr_no_err_stub 5
    isr_no_err_stub 6
    isr_no_err_stub 7
    isr_err_stub    8
    isr_no_err_stub 9
    isr_err_stub    10
    isr_err_stub    11
    isr_err_stub    12
    isr_err_stub    13
    isr_err_stub    14
    isr_no_err_stub 15
    isr_no_err_stub 16
    isr_err_stub    17
    isr_no_err_stub 18
    isr_no_err_stub 19
    isr_no_err_stub 20
    isr_no_err_stub 21
    isr_no_err_stub 22
    isr_no_err_stub 23
    isr_no_err_stub 24
    isr_no_err_stub 25
    isr_no_err_stub 26
    isr_no_err_stub 27
    isr_no_err_stub 28
    isr_no_err_stub 29
    isr_err_stub    30
    isr_no_err_stub 31

isr_stub_table:
%assign i 0 
%rep    32 
    dd isr_stub_%+i ; use DQ instead if targeting 64-bit
%assign i i+1 
%endrep

;functions

setup_idt:
    pusha
    mov si, word isr_stub_table
    mov di, word idt_table
    ;prepare for setup 32 stub entries
    mov cx, 31
.setloop:
    mov ax, word[si]
    mov word[di], ax
    add di, 6
    mov ax, word[si+2]
    mov word[di], ax
    add di, 2
    add si, 4
    loop .setloop
.done:
    popa
    ret