org 0x0500
bits 16

jmp main

ALIGN 4
tss:
    dw 0, 0
    dd 0
    dw 0x10, 0
    dd 0
    dw 0, 0
    dd 0
    dw 0, 0
    dd 0
    dd 0
    dd 0
    dd 0, 0, 0, 0
    dd 0, 0, 0, 0
    dw 0, 0
    dw 0, 0
    dw 0, 0
    dw 0, 0
    dw 0, 0
    dw 0, 0   
    dw 0, 0 
    dw 0, iopb_s-tss
iopb_s:
    times 8192 db 0xff
tss_eos:



gdt:
    dd 0
    dd 0
;CODE 0x08
    dw 0xFFFF ;limit
    dw 0 ;base high
    db 0 ;base mid
    db 10011010b ;access
    db 11001111b ;flag && limit low
    db 0 ;base low
;DATA 0x10
    dw 0xFFFF ;limit
    dw 0 ;base high
    db 0 ;base mid
    db 10010010b ;access
    db 11001111b ;flag && limit low
    db 0 ;base low
;UCODE 0x18
    dw 0xFFFF ;limit
    dw 0 ;base high
    db 0 ;base mid
    db 11111010b ;access
    db 11001111b ;flag && limit low
    db 0 ;base low
;UDATA 0x20
    dw 0xFFFF ;limit
    dw 0 ;base high
    db 0 ;base mid
    db 11110010b ;access
    db 11001111b ;flag && limit low
    db 0 ;base low
TSS_SEL equ $-gdt
;TSS 0x28
    dw tss_eos-tss-1
    dw 0
    db 0
    db 0x89
    db 0x00
    db 0

gdt_eos:
gdt_r:
    dw gdt_eos - gdt - 1
    dd gdt


%include "inc/disku.asm"
%include "inc/a20.asm"
%include "inc/idt.asm"
file2load: db "TEOS32  TEX"
filesz: dd 0
filesig: db "TEX1"

main:
    cli
    xor ax, ax
    mov ds, ax
    mov es, ax
    mov fs, ax
    mov gs, ax

    mov ss, ax
    mov sp, 0xFFFF
    sti

    cli
    in al, 0x70
    or al, 0x80
    out 0x70, al
    in al, 0x71

    call EnableA20
    
    call LoadEntries
    xor bx, bx
    mov bp, 0x3000
    mov si, file2load
    call LoadFile
    mov dword[filesz], ecx
    cmp ax, -1
    je haltSys

Switch2PM:
    call setup_idt
    cli
    lidt [idt_rt]
    lgdt [gdt_r]
    mov eax, cr0
    or al, 1
    mov cr0, eax
    jmp 0x08:PModeMain
haltSys:
    cli
    hlt

bits 32
PModeMain:
    ;set data segments
    mov ax, 0x10
    mov ds, ax
    mov es, ax
    mov fs, ax
    mov gs, ax
    mov ss, ax
    mov esp, 0x90000

    mov ax, TSS_SEL
    ltr ax ;IT STOPS THE MACHINE

    mov eax, dword[filesz]
    movzx ebx, word[BytesPerSector]
    mul ebx
    mov ebx, 4
    div ebx
    cld

    mov esi, 0x3000
    mov edi, 0x100000
    mov ecx, eax
    push edi
    rep movsd
    pop edi
    
    cmp dword[edi], "TEX1" ;file signature
    jne syshalt2
    add edi, 32
    
    mov ebp, edi
    ;set data segments
    mov ax, 0x10
    mov ds, ax
    mov es, ax
    mov fs, ax
    mov gs, ax
    mov ss, ax
    mov esp, 0x90000

    mov ebx, 0xBEBACAFE
    call ebp
syshalt2:
    cli
    hlt
    jmp $
